package fr.janua.client;

import com.google.gwt.user.client.ui.IsWidget;
import com.mvp4g.client.annotation.Event;
import com.mvp4g.client.annotation.Events;
import com.mvp4g.client.annotation.Start;
import com.mvp4g.client.event.EventBus;

import fr.janua.client.presenter.FooterPresenter;
import fr.janua.client.presenter.HeaderPresenter;
import fr.janua.client.presenter.MenuPresenter;
import fr.janua.client.presenter.PageAdminDocumentPresenter;
import fr.janua.client.presenter.PageDemoPresenter;
import fr.janua.client.presenter.PageDocumentPresenter;
import fr.janua.client.presenter.PageGroupPresenter;
import fr.janua.client.presenter.PageLogPresenter;
import fr.janua.client.presenter.PageLoginPresenter;
import fr.janua.client.presenter.PageMainCourantePresenter;
import fr.janua.client.presenter.PageSitePresenter;
import fr.janua.client.presenter.PageTypePresenter;
import fr.janua.client.presenter.PageUserPresenter;
import fr.janua.client.presenter.RootPresenter;
import fr.janua.shared.Action;

@Events( startPresenter = RootPresenter.class )
public interface JaguardsEventBus extends EventBus {
	@Start
	@Event(bind = {
			HeaderPresenter.class,
			MenuPresenter.class,
			FooterPresenter.class},
			handlers = RootPresenter.class)
	void start();

	@Event( handlers = RootPresenter.class )
	void setBody( IsWidget body );

	/**
	 * Affiche le statut de connexion, et le login de l'utilisateur si <code>isLogged</code> est à true.
	 * @param login
	 * @param isLogged
	 */
	@Event( handlers = MenuPresenter.class )
	void setStatusConnection(String login, boolean isLogged);

	@Event( handlers = AppControllManager.class )
	void refreshLastActivityUser();
	
	@Event( handlers = AppControllManager.class )
	void refreshUserWithoutChangePassword();
	
	@Event( handlers = AppControllManager.class )
	void refreshUser(String login, String password);
	
	@Event( handlers = AppControllManager.class )
	void reloadDB();
	
	/*
	 * Changement de page
	 */
	
	@Event( handlers = PageUserPresenter.class )
	void goToPageUser();
	
	@Event( handlers = PageMainCourantePresenter.class )
	void goToPageMainCourante();
	
	@Event( handlers = PageDocumentPresenter.class )
	void goToPageDocument();
	
	@Event( handlers = PageGroupPresenter.class )
	void goToPageGroup();
	
	@Event( handlers = PageTypePresenter.class )
	void goToPageType();
	
	@Event( handlers = PageSitePresenter.class )
	void goToPageSite();

	@Event( handlers = PageAdminDocumentPresenter.class )
	void goToPageAdminDocument();
	
	@Event( handlers = PageLogPresenter.class )
	void goToPageLog();

	@Event( handlers = PageLoginPresenter.class )
	void goToPageLogin();
	
	@Event( handlers = PageDemoPresenter.class )
	void goToPageDemo();
	
	/* Timer */
	@Event( handlers = AppControllManager.class )
	void activity();

	/* Log */
	@Event( handlers = AppControllManager.class )
	void addLog(Action action, String detail);

	

	

	

	

	

	

	

	
	

	

	

	


	

	

	
	


	

	
	
}