package fr.janua.client.stub;

import java.util.List;

import com.google.web.bindery.requestfactory.shared.Request;
import com.google.web.bindery.requestfactory.shared.RequestContext;
import com.google.web.bindery.requestfactory.shared.Service;

import fr.janua.client.proxy.GroupProxy;
import fr.janua.server.dao.object.GroupDAO;
import fr.janua.server.locator.DAOLocator;

@Service(value = GroupDAO.class, locator = DAOLocator.class)
public interface GroupRequest extends RequestContext {
	// méthodes génériques des DAO
	Request<Boolean> create(GroupProxy group);
	Request<Boolean> delete(GroupProxy group);
	Request<Boolean> update(GroupProxy group);
	Request<GroupProxy> findById(int id);
	
	// méthodes propres à cette DAO
	Request<GroupProxy> findByName(String name);
	Request<List<GroupProxy>> findAllGroup();
	Request<Boolean> isAdminExist();
	Request<Boolean> addSite(String groupName, String siteName);
	Request<Boolean> addType(String groupName, String typeName);
	Request<GroupProxy> getGroupAdmin();
	Request<Void> resetForDemoMode();
}
