package fr.janua.client.stub;

import java.util.List;

import com.google.web.bindery.requestfactory.shared.Request;
import com.google.web.bindery.requestfactory.shared.RequestContext;
import com.google.web.bindery.requestfactory.shared.Service;

import fr.janua.client.proxy.MessageProxy;
import fr.janua.client.proxy.TypeProxy;
import fr.janua.server.dao.object.MessageDAO;
import fr.janua.server.locator.DAOLocator;

@Service(value = MessageDAO.class, locator = DAOLocator.class)
public interface MessageRequest extends RequestContext {
	// méthodes génériques des DAO
	Request<Boolean> create(MessageProxy message);
	Request<Boolean> delete(MessageProxy message);
	Request<Boolean> update(MessageProxy message);
	Request<MessageProxy> findById(int id);
	
	// méthodes propres à cette DAO
	Request<List<MessageProxy>> findOpenMessages(int startIndex, int nbMessage, List<String> sites, List<String> types);
	Request<List<MessageProxy>> findClosedMessages(int startIndex, int nbMessage, List<String> sites, List<String> types);
	Request<Integer> getOpenMessageCount(List<String> sites, List<String> types);
	Request<Integer> getClosedMessageCount(List<String> sites, List<String> types);
	Request<Boolean> addComment(int idMessage, String description, String author, String groupName);
	Request<Boolean> addType(int idMessage, TypeProxy type, String login, String groupName);
	Request<List<MessageProxy>> search(String wordSearch);
	Request<Boolean> generatePdf(int idMessage);
}
