package fr.janua.client.stub;

import java.util.List;

import com.google.web.bindery.requestfactory.shared.Request;
import com.google.web.bindery.requestfactory.shared.RequestContext;
import com.google.web.bindery.requestfactory.shared.Service;

import fr.janua.client.proxy.SiteProxy;
import fr.janua.server.dao.object.SiteDAO;
import fr.janua.server.locator.DAOLocator;

@Service(value = SiteDAO.class, locator = DAOLocator.class)
public interface SiteRequest extends RequestContext {
	// méthodes génériques des DAO
	Request<Boolean> create(SiteProxy site);
	Request<Boolean> delete(SiteProxy site);
	Request<Boolean> update(SiteProxy site);
	Request<SiteProxy> findById(int id);
	
	// méthodes propres à cette DAO
	Request<SiteProxy> findByName(String name);
	Request<List<SiteProxy>> findAllSite();
}
