package fr.janua.client.view;

import com.google.gwt.core.client.GWT;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.ui.Anchor;
import com.google.gwt.user.client.ui.Widget;

import fr.janua.client.internationalization.JaguardsConstants;
import fr.janua.client.view.interfaces.IPageDocumentView;
import fr.janua.client.view.interfaces.IPageDocumentView.IPageDocumentPresenter;

/**
 * 
 * @author Gilles Phan
 *
 */
public class PageDocumentView extends ReverseCompositeView<IPageDocumentPresenter> implements IPageDocumentView {
	
	private JaguardsConstants constants = GWT.create(JaguardsConstants.class);
	private static PageDocumentViewUiBinder uiBinder = GWT.create(PageDocumentViewUiBinder.class);

	
	@UiField Anchor	anchor_userManual, anchor_securityGuide, anchor_serviceRequest;
	
	
	interface PageDocumentViewUiBinder extends UiBinder<Widget, PageDocumentView> {}

	public PageDocumentView() {
		initWidget(uiBinder.createAndBindUi(this));
	}
	
	/* Override */

	@Override
	public void createView() {
	}

	@Override
	public void loadPage() {
		anchor_userManual.setHref("doc/user_manual-" + constants.currentLanguage() + ".pdf");
		anchor_securityGuide.setHref("doc/security_guide-" + constants.currentLanguage() + ".pdf");
		anchor_serviceRequest.setHref("doc/service_request-" + constants.currentLanguage() + ".pdf");
	}

	/* Fonction */

	/* Handler */
}
