package fr.janua.client.view;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.Event;
import com.google.gwt.user.client.ui.IsWidget;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.Widget;
import com.google.inject.Inject;

import fr.janua.client.view.interfaces.IRootView;
import fr.janua.client.view.interfaces.IRootView.IRootPresenter;

public class RootView extends ReverseCompositeView<IRootPresenter> implements IRootView {

	private static RootViewUiBinder uiBinder = GWT.create(RootViewUiBinder.class);

	@UiField (provided = true)
	Widget header, menu, footer;
	
	@UiField
	SimplePanel body;
	
	interface RootViewUiBinder extends UiBinder<Widget, RootView> {
	}

	@Inject
	public RootView(HeaderView header, MenuView menu, FooterView footer) {
		this.header = header;
		this.menu = menu;
		this.footer = footer;
		initWidget(uiBinder.createAndBindUi(this));
		
		// Relance du timer
		
		// click sur la partie "body"
		body.sinkEvents(Event.ONCLICK);
		body.addHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				presenter.click();
			}
		}, ClickEvent.getType());
		// keyup sur la partie "body"
		body.sinkEvents(Event.ONKEYUP);
		body.addHandler(new KeyUpHandler() {
			
			@Override
			public void onKeyUp(KeyUpEvent event) {
				presenter.click();
			}
		}, KeyUpEvent.getType());
		// click sur la partie "menu"
		menu.sinkEvents(Event.ONCLICK);
		menu.addHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				presenter.click();
			}
		}, ClickEvent.getType());
		// click sur la partie "footer"
		footer.sinkEvents(Event.ONCLICK);
		footer.addHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				presenter.click();
			}
		}, ClickEvent.getType());
	}

	@Override
	public void setBody(IsWidget body) {
		this.body.setWidget( body );
	}


}
