package fr.janua.client.view.interfaces;

import com.google.gwt.user.client.ui.IsWidget;
import com.mvp4g.client.view.LazyView;

import fr.janua.shared.Log;

public interface IPageLogView extends IsWidget , LazyView {
	public interface IPageLogPresenter{

		/**
		 * Envoie une requête pour récupérer une liste des n derniers logs.
		 */
		void getFirstPageLog();

		/**
		 * Demande à la base de donnée combien de logs elle contient. A partir d'un certain nombre, on va générer une pagination pour l'ihm.
		 * Cette méthode entrainera le chargement de la première page de Log.
		 */
		void generatePagination();

		/**
		 * Demande au presenter d'aller à la page précédente.
		 */
		void previousPage();
		/**
		 * Demande au presenter d'aller à la page suivante.
		 */
		void nextPage();
		
	}

	/**
	 * Fonction appelée à chaque fois que l'on va charger la page.
	 * @param name
	 */
	void loadPage();

	/**
	 * Affiche une ligne de logs.
	 * @param log
	 */
	void displayOneLog(Log log);

	/**
	 * Affiche la pagination.
	 * @param currentPage
	 * @param nbPage le nombre de page à générer dans la pagination.
	 */
	void displayPagination(int currentPage, int nbPage);

	void clearPanelLog();


}
