package fr.janua.client.view.interfaces;

import com.google.gwt.user.client.ui.IsWidget;
import com.mvp4g.client.view.LazyView;

public interface IPageLoginView extends IsWidget , LazyView {
	public interface IPageLoginPresenter{

		/**
		 * Vérifie le login et mot de passe de l'utilisateur, avant de le rediriger.
		 * @param login
		 * @param password
		 */
		void checkSignIn(String login, String password);


		void initDbStep1();

		void initDbStep2();


		/**
		 * Recharge le fichier de configuration de la base de données.
		 */
		void reloadDB();


	}

	/**
	 * Fonction appelée à chaque fois que l'on va charger la page.
	 * @param name
	 */
	void loadPage();

	/**
	 * Efface les champs "login" et "password".
	 */
	void clearField();

	
	void incrProgressSite();
	void incrProgressType();
	void incrProgressAdmin();
	void incrProgressAssoc();

	/**
	 * Affiche ou masque le bouton "warning"
	 * @param visible
	 */
	void setWarningVisible(boolean visible);

}
