package fr.janua.client.view.interfaces;

import com.google.gwt.user.client.ui.IsWidget;
import com.mvp4g.client.view.LazyView;

public interface IPageSiteView extends IsWidget , LazyView {
	public interface IPageSitePresenter{

		/**
		 * Envoie une requête pour récupérer la liste de tous les Sites.
		 */
		void getAllSite();

		/**
		 * Met à jour le Site passé en paramètre.
		 * @param siteUpdated
		 */
		void updateSite(String name, boolean isEnabled);

		/**
		 * Créer un nouveau Site.
		 * @param newSite
		 */
		void createSite(String name, boolean isEnabled);
		
	}

	/**
	 * Fonction appelée à chaque fois que l'on va charger la page.
	 * @param name
	 */
	void loadPage();

	/**
	 * Affiche un Site : son nom, s'il est affichable et un bouton "Mettre à jour".
	 * @param site
	 */
	void displayOneSite(String nameSite, boolean enabled);

}
