package fr.janua.server;

import java.util.List;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import fr.janua.client.LogService;
import fr.janua.server.dao.DAOFactory;
import fr.janua.server.dao.object.LogDAO;
import fr.janua.shared.Log;

/**
 * The server side implementation of the RPC service.
 */
@SuppressWarnings("serial")
public class LogServiceImpl extends RemoteServiceServlet implements LogService {

	@Override
	public void addLog(Log log) {
		// ajout de la date et de l'ip (faisable que par la partie serveur) 
		log.setDate(System.currentTimeMillis());
		log.setIp(getThreadLocalRequest().getRemoteAddr());

		// instantiation de LogDAO
		LogDAO logDAO = DAOFactory.getLogDAO();
		
		// Ajout du nouveau Log
		logDAO.create(log);
	}

	@Override
	public Number getNbLog() {
		// instantiation de LogDAO
		LogDAO logDAO = DAOFactory.getLogDAO();

		// Recherche du nombre de Log
		Integer nbLog = logDAO.getLogCount();

		return nbLog;
	}

	@Override
	public List<Log> getLog(int startIndex, int nbElem) {

		// instantiation de LogDAO
		LogDAO logDAO = DAOFactory.getLogDAO();

		// Récupère une liste de n Log
		List<Log> listLog = logDAO.findLog(startIndex, nbElem);

		return listLog;
	}

}
