package fr.janua.server.dao.object;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import fr.janua.server.dao.DAO;
import fr.janua.server.entity.Site;
import fr.janua.server.utils.HibernateUtils;

public class SiteDAO extends DAO<Site>{

	public SiteDAO() {
		super();
	}

	@Override
	public boolean create(Site site) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			session.save(site);
			tx.commit();
		} catch (Exception e) {
			e.printStackTrace();
			if (tx != null && session.isOpen())
				tx.rollback();
			System.out.println("[Site] create(" + site.getName() + ") : not ok !!");
			return false;
		}finally{
			session.close();
		}
		return true;
	}

	@Override
	public boolean delete(Site site) {
		// TODO : à coder
		return false;
	}

	@Override
	public boolean update(Site site) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			session.update(site);
			tx.commit();
		}catch (Exception e) {
			e.printStackTrace();
			if (tx != null && session.isOpen())
				tx.rollback();
			return false;
		}finally{
			session.close();
		}
		return true;
	}

	@Override
	public Site findById(int id) {
		System.err.println("Site n'a pas d'id. Utiliser la fonction finByName !");
		return null;
	}
	
	public Site findByName(String name) {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Query query = session.createQuery("SELECT site FROM Site site WHERE site.name = :name");
		query.setParameter("name", name);
		Site site = (Site) query.uniqueResult();
		session.close();
		
		return site;
	}

	/**
	 * Récupère tous les Sites de la base de donnée.
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public List<Site> findAllSite() {
		Session session = HibernateUtils.getSessionFactory().openSession();
		Query query = session.createQuery("SELECT site FROM Site site");
		List<Site> list = query.list();
		session.close();
		
		return list;
	}

}
