package fr.janua.server.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Version;


@Entity(name = "Comment")
@Table(name = "t_comment")
public class Comment{
	@Id
	@Column(name="comment_id")
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private int id;

	@Column(name="comment_description", length=2500)
	private String description;

	@Column(name="comment_date")
	private long date;
	
	@Column(name="comment_author")
	private String author;
	
	@Column(name="comment_group_name")
	private String groupName;
	
//	@Column(name="comment_type")
	@ManyToOne
	@JoinColumn(name = "comment_type", referencedColumnName = "type_name")
	private Type type;
	
	/*@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumn(name="comment_message")
	private Message message;*/
	
	@Version
	@Column(name = "comment_version")
	// @NotNull
	private Integer version;
	
	
	
	/* Constructeurs */
	
	/**
	 * Constructeur vide.
	 */
	public Comment() {}

	/**
	 * Constructeur par défaut de la classe Comment.
	 * @param id
	 * @param description
	 * @param date
	 * @param author
	 * @param groupName
	 * @param type
	 * @param version
	 */
	public Comment(int id, String description, long date, String author,
			String groupName, Type type, Integer version) {
		this.id = id;
		this.description = description;
		this.date = date;
		this.author = author;
		this.groupName = groupName;
		this.type = type;
		this.version = version;
	}

	
	/* Accesseurs / Mutateurs */

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return the date
	 */
	public long getDate() {
		return date;
	}

	/**
	 * @param date the date to set
	 */
	public void setDate(long date) {
		this.date = date;
	}

	/**
	 * @return the author
	 */
	public String getAuthor() {
		return author;
	}

	/**
	 * @param author the author to set
	 */
	public void setAuthor(String author) {
		this.author = author;
	}

	/**
	 * @return the groupName
	 */
	public String getGroupName() {
		return groupName;
	}

	/**
	 * @param groupName the groupName to set
	 */
	public void setGroupName(String groupName) {
		this.groupName = groupName;
	}

	/**
	 * @return the type
	 */
	public Type getType() {
		return type;
	}

	/**
	 * @param type the type to set
	 */
	public void setType(Type type) {
		this.type = type;
	}

	/**
	 * @return the version
	 */
	public Integer getVersion() {
		return version;
	}

	/**
	 * @param version the version to set
	 */
	public void setVersion(Integer version) {
		this.version = version;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Comment [id=" + id + ", description=" + description + ", date="
				+ date + ", author=" + author + ", groupName=" + groupName
				+ ", type=" + type + ", version=" + version + "]";
	}

	
	



	
		
}
