package fr.janua.server.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Version;


@Entity(name = "Site")
@Table(name = "t_site")
public class Site{
	@Id
	@Column(name="site_name")
	private String name;

	@Column(name="site_enabled")
	private boolean enabled;
	
	@Version
	@Column(name = "site_version")
//	@NotNull
	private Integer version;
	
	
	
	/* Constructeurs */
	
	/**
	 * Constructeur vide.
	 */
	public Site() {}

	/**
	 * Constructeur par défaut de la classe Site.
	 * @param name
	 * @param enabled
	 * @param version
	 */
	public Site(String name, boolean enabled, Integer version) {
		this.name = name;
		this.enabled = enabled;
		this.version = version;
	}

	
	
	/* Accesseurs / Mutateurs */
	
	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}
	/**
	 * @return the enabled
	 */
	public boolean isEnabled() {
		return enabled;
	}
	/**
	 * @param enabled the enabled to set
	 */
	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}
	/**
	 * @return the version
	 */
	public Integer getVersion() {
		return version;
	}
	/**
	 * @param version the version to set
	 */
	public void setVersion(Integer version) {
		this.version = version;
	}
	
	
	
	@Override
	public String toString() {
		return "Site [name=" + name + ", enabled=" + enabled
				+ ", version=" + version + "]";
	}
	

	
	
	
}
