package fr.janua.server.locator;

import com.google.web.bindery.requestfactory.shared.ServiceLocator;

import fr.janua.server.dao.DAOFactory;
import fr.janua.server.dao.object.CommentDAO;
import fr.janua.server.dao.object.GroupDAO;
import fr.janua.server.dao.object.MessageDAO;
import fr.janua.server.dao.object.SiteDAO;
import fr.janua.server.dao.object.TypeDAO;
import fr.janua.server.dao.object.UserDAO;

public class DAOLocator implements ServiceLocator {

	@Override
	public Object getInstance(Class<?> clazz) {
		if(clazz == UserDAO.class)
			return DAOFactory.getUserDAO();
		else if(clazz == GroupDAO.class)
			return DAOFactory.getGroupDAO();
		else if(clazz == SiteDAO.class)
			return DAOFactory.getSiteDAO();
		else if(clazz == TypeDAO.class)
			return DAOFactory.getTypeDAO();
		else if(clazz == MessageDAO.class)
			return DAOFactory.getMessageDAO();
		else if(clazz == CommentDAO.class)
			return DAOFactory.getCommentDAO();
		else{
			try {
				return clazz.newInstance();
			} catch (InstantiationException e) {
				throw new RuntimeException(e);
			} catch (IllegalAccessException e) {
				throw new RuntimeException(e);
			}
		}
	}

}
