package fr.janua.server.locator;

import com.google.web.bindery.requestfactory.shared.Locator;

import fr.janua.server.dao.DAOFactory;
import fr.janua.server.dao.object.GroupDAO;
import fr.janua.server.entity.Group;

public class GroupLocator extends Locator<Group, String> {

	@Override
	public Group create(Class<? extends Group> clazz) {
		return new Group();
	}

	@Override
	public Group find(Class<? extends Group> clazz, String id) {
		return getGroupDao().findByName(id);
	}

	@Override
	public Class<Group> getDomainType() {
		return Group.class;
	}

	@Override
	public String getId(Group domainObject) {
		return domainObject.getName();
	}

	@Override
	public Class<String> getIdType() {
		return String.class;
	}

	@Override
	public Object getVersion(Group domainObject) {
		return domainObject.getVersion();
	}

	/**
	 * Récupère le GroupDAO.
	 * 
	 * @return
	 */
	private GroupDAO getGroupDao() {
		return DAOFactory.getGroupDAO();
	}
}
