package fr.janua.server.locator;

import com.google.web.bindery.requestfactory.shared.Locator;

import fr.janua.server.dao.DAOFactory;
import fr.janua.server.dao.object.MessageDAO;
import fr.janua.server.entity.Message;

public class MessageLocator extends Locator<Message, Integer> {

	@Override
	public Message create(Class<? extends Message> clazz) {
		return new Message();
	}

	@Override
	public Message find(Class<? extends Message> clazz, Integer id) {
		return getMessageDao().findById(id);
	}

	@Override
	public Class<Message> getDomainType() {
		return Message.class;
	}

	@Override
	public Integer getId(Message domainObject) {
		return domainObject.getId();
	}

	@Override
	public Class<Integer> getIdType() {
		return Integer.class;
	}

	@Override
	public Object getVersion(Message domainObject) {
		return domainObject.getVersion();
	}

	/**
	 * Récupère le MessageDAO.
	 * 
	 * @return
	 */
	private MessageDAO getMessageDao() {
		return DAOFactory.getMessageDAO();
	}
}
