package fr.janua.server.locator;

import com.google.web.bindery.requestfactory.shared.Locator;

import fr.janua.server.dao.DAOFactory;
import fr.janua.server.dao.object.SiteDAO;
import fr.janua.server.entity.Site;

public class SiteLocator extends Locator<Site, String> {

	@Override
	public Site create(Class<? extends Site> clazz) {
		return new Site();
	}

	@Override
	public Site find(Class<? extends Site> clazz, String id) {
		return getSiteDao().findByName(id);
	}

	@Override
	public Class<Site> getDomainType() {
		return Site.class;
	}

	@Override
	public String getId(Site domainObject) {
		return domainObject.getName();
	}

	@Override
	public Class<String> getIdType() {
		return String.class;
	}

	@Override
	public Object getVersion(Site domainObject) {
		return domainObject.getVersion();
	}

	/**
	 * Récupère l'SiteDAO.
	 * 
	 * @return
	 */
	private SiteDAO getSiteDao() {
		return DAOFactory.getSiteDAO();
	}
}
