package fr.janua.server.locator;

import com.google.web.bindery.requestfactory.shared.Locator;

import fr.janua.server.dao.DAOFactory;
import fr.janua.server.dao.object.TypeDAO;
import fr.janua.server.entity.Type;

public class TypeLocator extends Locator<Type, String> {

	@Override
	public Type create(Class<? extends Type> clazz) {
		return new Type();
	}

	@Override
	public Type find(Class<? extends Type> clazz, String id) {
		return getTypeDao().findByName(id);
	}

	@Override
	public Class<Type> getDomainType() {
		return Type.class;
	}

	@Override
	public String getId(Type domainObject) {
		return domainObject.getName();
	}

	@Override
	public Class<String> getIdType() {
		return String.class;
	}

	@Override
	public Object getVersion(Type domainObject) {
		return domainObject.getVersion();
	}

	/**
	 * Récupère le TypeDAO.
	 * 
	 * @return
	 */
	private TypeDAO getTypeDao() {
		return DAOFactory.getTypeDAO();
	}
}
